//---------------------------------------------------------------------------

#include <vcl.h>
#include <iterator>
#include "algostuff.hpp"

#include <conio.h> //  getch()

#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused
using namespace std;

std::string ToRus(const std::string &in)
{
  char *buff = new char [in.length()+1];
  CharToOem(in.c_str(),buff);
  std::string out(buff);
  delete [] buff;
  return out;
}


int main()
{
  //  
  int source[] = { 1, 4, 4, 6, 1, 2, 2, 3, 1, 6, 6, 6, 5, 7,
                    5, 4, 4 };
  int sourceNum = sizeof(source)/sizeof(source[0]);

  list<int> coll;

  //  coll  source
  copy (source, source+sourceNum,           // 
        back_inserter(coll));               // 
  PRINT_ELEMENTS(coll," :\n");

  //   
  list<int>::iterator pos;
  pos = unique (coll.begin(), coll.end());

  //   
  //   -     
  cout << ToRus("    :\n");
  copy (coll.begin(), pos,                  // 
        ostream_iterator<int>(cout," "));   // 
  cout << "\n\n";

  //   coll  source
  copy (source, source+sourceNum,           // 
        coll.begin());                      // 
  PRINT_ELEMENTS(coll," :\n");

  //  ,       
  coll.erase (unique (coll.begin(), coll.end(),
                      greater<int>()),
              coll.end());
  PRINT_ELEMENTS(coll,"   , \n    :\n");


  getch();
  return 0;
}

//---------------------------------------------------------------------------